searchNodes=[{"type":"module","title":"logger_formatter_json","doc":"Formatter for the Erlang logger library which outputs JSON. https://www.erlang.org/doc/apps/kernel/logger_chapter.html#formatters","ref":"logger_formatter_json.html"},{"type":"function","title":"logger_formatter_json.check_config/1","doc":"","ref":"logger_formatter_json.html#check_config/1"},{"type":"function","title":"logger_formatter_json.format/2","doc":"","ref":"logger_formatter_json.html#format/2"},{"type":"type","title":"logger_formatter_json.config/0","doc":"","ref":"logger_formatter_json.html#t:config/0"},{"type":"type","title":"logger_formatter_json.metakey/0","doc":"","ref":"logger_formatter_json.html#t:metakey/0"},{"type":"type","title":"logger_formatter_json.template/0","doc":"","ref":"logger_formatter_json.html#t:template/0"},{"type":"extras","title":"Overview","doc":"logger_formatter_json This is a formatter for the Erlang logger application that outputs JSON. When logging text messages, it outputs the text message under the msg key along with logger metadata such as OpenTelemetry trace ids. It also supports &quot;structured&quot; logging of maps, e.g. logger:info(\#{foo =&gt; bar}) . Metadata values can also be maps. You can control the order of output keys to put the message first, avoiding having to read a big mess of JSON to find the important parts. You can configure the names of output keys to support naming conventions from services such as Datadog and Google Cloud It implements the formatter API for the high-performance logger application introduced in OTP 21. It is written in Erlang with no dependencies except for the Erlang JSON library thoas . It can be used by pure Erlang projects as well as other BEAM languages such as Elixir.","ref":"readme.html"},{"type":"extras","title":"Overview - Installation","doc":"Erlang: Add logger_formatter_json to the list of dependencies in rebar.config : { deps , [ logger_formatter_json ] } . Elixir: Add logger_formatter_json to the list of dependencies in mix.exs : def deps do [ { :logger_formatter_json , &quot;~&gt; 0.8&quot; } , ] end","ref":"readme.html#installation"},{"type":"extras","title":"Overview - Configuration","doc":"JSON output is useful for production, as it allows you parse and query log records to, e.g., match on a particular user. It can be excessively verbose for development, however, so we stick with the normal Elixir logger for development. For Erlang, flatlog is a similar user-friendly library. In order to make all log output in consistent JSON format, including system messages, we configure the formatter as the default for all applications running on the VM. Erlang: Configure the kernel default handler in the sys.config file for the release: [ { kernel , [ { logger , [ { handler , default , logger_std_h , \#{ formatter =&gt; { logger_formatter_json , \#{ } } } } ] } , { logger_level , info } ] } ] . Elixir: As of Elixir 15, we can override the formatter for the default log handler easily. In config/prod.exs configure :default_handler : config :logger , :default_handler , formatter : { :logger_formatter_json , %{ } } Or, with options (see below): config :logger , :default_handler , formatter : { :logger_formatter_json , %{ template : [ :msg , :time , :level , :file , :line , # :mfa, :pid , :request_id , :otel_trace_id , :otel_span_id , :otel_trace_flags ] } } In older Elixir versions, it was tricky to configure the default handler from Elixir. Instead, we would reconfigure the default handler in the app startup. In config/prod.exs or config/runtime.exs , define the formatter config: config :foo , :logger_formatter_config , { :logger_formatter_json , %{ } } Or, with options (see below): config :foo , :logger_formatter_config , { :logger_formatter_json , %{ template : [ :msg , :time , :level , :file , :line , # :mfa, :pid , :request_id , :otel_trace_id , :otel_span_id , :otel_trace_flags ] } } Next, in in your application startup file, e.g., lib/foo/application.ex , add a call to reconfigure the logger: def start ( _type , _args ) do logger_formatter_config = Application . get_env ( :foo , :logger_formatter_config ) if logger_formatter_config do :logger . update_handler_config ( :default , :formatter , logger_formatter_config ) end If you want all the messages from the initial startup in JSON as well, you have to configure the logger as a VM arg for the release. In rel/vm.args.eex , set up the logger: - kernel logger &#39;[{handler, default, logger_std_h, \#{formatter =&gt; {logger_formatter_json, \#{}}}}]&#39; or, with options: - kernel logger &#39;[{handler, default, logger_std_h, \#{formatter =&gt; {logger_formatter_json, \#{template =&gt; [msg, time, level, file, line, mfa, pid, otel_trace_id, otel_span_id, otel_trace_flags]}}}}]&#39; There used to be a way of doing this in Elixir, but it seems to have stopped working. In config/prod.exs or config/runtime.exs , define the formatter config: if System . get_env ( &quot;RELEASE_MODE&quot; ) do config :kernel , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ } } } } ] end The check for the RELEASE_MODE environment variable makes the code only run when building a release.","ref":"readme.html#configuration"},{"type":"extras","title":"Overview - Usage","doc":"The formatter accepts a map of options, e.g.: config :foo , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ names : %{ time : &quot;date&quot; , level : &quot;status&quot; , msg : &quot;message&quot; } } } } } ] names is a map of keys in the metadata map to string keys in the JSON output. The module has predefined sets of keys for datadog and gcp . config :foo , :logger , [ { :handler , :default , :logger_std_h , %{ formatter : { :logger_formatter_json , %{ names : :datadog } } } } ] You can also specify a list to add your own tags to the predefined ones, e.g. of options, e.g. names: [datadog, %{foo: &quot;bar&quot;}] . types is a map which identifies keys with a special format that the module understands ( level , system_time , mfa ). template is a list of metadata to format. This lets you put keys in specific order to make them easier to read in the output. For example: template : [ :msg , :time , :level , :file , :line , :mfa , :pid , :otel_trace_id , :otel_span_id , :otel_trace_flags ] List elements are metadata key names, with a few special keys: msg represents the text message, if any. If you call logger:info(&quot;the message&quot;) , then it would be rendered in the JSON as {&quot;msg&quot;: &quot;the message&quot;, ...} . You can map the key msg to e.g. message via the names config option. all represents all the metadata keys. rest represents all the metadata keys which have not been handled explicitly. You can specify a group of keys as a tuple like {group, &lt;name&gt;, [&lt;list of metadata keys&gt;]} , and they will be collected into a map in the output. For example: { group , source_location , [ file , line , mfa ] } , { group , tags , [ rest ] } This would result in a log message like: { ... &quot;source_location&quot;: {&quot;file&quot;: &quot;mymodule.ex&quot;, &quot;line&quot;: 17, &quot;mfa&quot;: &quot;mymodule:thefunction/1&quot;}, &quot;tags&quot;: {&quot;foo&quot;: &quot;bar&quot;, &quot;biz&quot;: &quot;baz&quot;} } The default template is [msg, rest] . You can also use a tuple to specify a standard set of keys to be used: {keys, basic} : [time, level, msg] {keys, trace} : [trace_id, span_id] {keys, otel} : [otel_trace_id, otel_span_id, otel_trace_flags] {keys, gcp} : [ msg , time , level , otel_trace_id , otel_span_id , { group , source_location , [ file , line , mfa ] } , { group , tags , [ rest ] } ] You can specify multiple templates, so you can add your own metadata keys to one of the standard templates, e.g., [{keys, basic}, request_id, trace_id, span_id] . When logging maps, default ( embed ) puts the map under the msg key. If you set the config option map_msg to merge , then the keys of the map will be merged into the metadata. So logger:info(\#{hi =&gt; there}} is logged as {&quot;level&quot;:&quot;info&quot;,&quot;hi&quot;:&quot;there&quot;} . This lets you control how the fields appear in the output with the template, e.g., a template of [level, biz] would result in output of {&quot;level&quot;:&quot;info&quot;,&quot;biz&quot;:&quot;baz&quot;} for the message logger:info(\#{foo =&gt; bar, biz =&gt; baz}} .","ref":"readme.html#usage"},{"type":"extras","title":"Overview - Acknowledgements","doc":"Much thanks to Fred Hebert, as always. His flatlog library was a significant inspiration.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"Overview - Links","doc":"Erlang/OTP 21's new logger Canonical log lines","ref":"readme.html#links"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [0.8.2] - 2024-04-07","doc":"Fixed Correct logging of non-printable characters. Data for which io_lib:printable_unicode_list/1 returns true is logged as a string. Embedded newlines are escaped using JSON rules, i.e., encoded as &quot;\\n&quot;. Other data, e.g., binaries, is encoded using io_lib:format &quot;~tp&quot;.","ref":"changelog.html#0-8-2-2024-04-07"},{"type":"extras","title":"Changelog - [0.8.1] - 2024-01-04","doc":"Added Upgrade thoas version Update CONTRIBUTING.md","ref":"changelog.html#0-8-1-2024-01-04"},{"type":"extras","title":"Changelog - [0.8.0] - 2024-01-04","doc":"Added Support structured logging Add map_msg config param","ref":"changelog.html#0-8-0-2024-01-04"},{"type":"extras","title":"Changelog - [0.7.3] - 2023-10-30","doc":"Added Updated docs for Elixir 1.15","ref":"changelog.html#0-7-3-2023-10-30"},{"type":"extras","title":"Changelog - [0.7.2] - 2023-10-23","doc":"Added Improved docs to cover latest Elixir Updated test matrix for latest Elixir and OTP","ref":"changelog.html#0-7-2-2023-10-23"},{"type":"extras","title":"Changelog - [0.7.1] - 2023-10-15","doc":"Fixed Handle log messages with Unicode","ref":"changelog.html#0-7-1-2023-10-15"},{"type":"extras","title":"Changelog - [0.7.0] - 2023-03-20","doc":"Added Initial version","ref":"changelog.html#0-7-0-2023-03-20"},{"type":"extras","title":"License (Apache 2.0)","doc":"Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"License (Apache 2.0) - 1. Definitions.","doc":"&quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"License (Apache 2.0) - 2. Grant of Copyright License.","doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"License (Apache 2.0) - 3. Grant of Patent License.","doc":"Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"License (Apache 2.0) - 4. Redistribution.","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: You must give any other recipients of the Work or Derivative Works a copy of this License; and You must cause any modified files to carry prominent notices stating that You changed the files; and You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"License (Apache 2.0) - 5. Submission of Contributions.","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"License (Apache 2.0) - 6. Trademarks.","doc":"This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"License (Apache 2.0) - 7. Disclaimer of Warranty.","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON- INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"License (Apache 2.0) - 8. Limitation of Liability.","doc":"In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"License (Apache 2.0) - 9. Accepting Warranty or Additional Liability.","doc":"While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS Copyright 2023, Jake Morrison jake@cogini.com . Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"},{"type":"extras","title":"Code of Conduct","doc":"","ref":"code_of_conduct.html"},{"type":"extras","title":"Code of Conduct - Our Pledge","doc":"We as members, contributors, and leaders pledge to make participation in our community a harassment-free experience for everyone, regardless of age, body size, visible or invisible disability, ethnicity, sex characteristics, gender identity and expression, level of experience, education, socio-economic status, nationality, personal appearance, race, caste, color, religion, or sexual identity and orientation. We pledge to act and interact in ways that contribute to an open, welcoming, diverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Code of Conduct - Our Standards","doc":"Examples of behavior that contributes to a positive environment for our community include: Demonstrating empathy and kindness toward other people Being respectful of differing opinions, viewpoints, and experiences Giving and gracefully accepting constructive feedback Accepting responsibility and apologizing to those affected by our mistakes, and learning from the experience Focusing on what is best not just for us as individuals, but for the overall community Examples of unacceptable behavior include: The use of sexualized language or imagery, and sexual attention or advances of any kind Trolling, insulting or derogatory comments, and personal or political attacks Public or private harassment Publishing others' private information, such as a physical or email address, without their explicit permission Other conduct which could reasonably be considered inappropriate in a professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Code of Conduct - Enforcement Responsibilities","doc":"Community leaders are responsible for clarifying and enforcing our standards of acceptable behavior and will take appropriate and fair corrective action in response to any behavior that they deem inappropriate, threatening, offensive, or harmful. Community leaders have the right and responsibility to remove, edit, or reject comments, commits, code, wiki edits, issues, and other contributions that are not aligned to this Code of Conduct, and will communicate reasons for moderation decisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Code of Conduct - Scope","doc":"This Code of Conduct applies within all community spaces, and also applies when an individual is officially representing the community in public spaces. Examples of representing our community include using an official e-mail address, posting via an official social media account, or acting as an appointed representative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Code of Conduct - Enforcement","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be reported to the community leaders responsible for enforcement at engineering@therealreal.com. All complaints will be reviewed and investigated promptly and fairly. All community leaders are obligated to respect the privacy and security of the reporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Code of Conduct - Enforcement Guidelines","doc":"Community leaders will follow these Community Impact Guidelines in determining the consequences for any action they deem in violation of this Code of Conduct: 1. Correction Community Impact : Use of inappropriate language or other behavior deemed unprofessional or unwelcome in the community. Consequence : A private, written warning from community leaders, providing clarity around the nature of the violation and an explanation of why the behavior was inappropriate. A public apology may be requested. 2. Warning Community Impact : A violation through a single incident or series of actions. Consequence : A warning with consequences for continued behavior. No interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, for a specified period of time. This includes avoiding interactions in community spaces as well as external channels like social media. Violating these terms may lead to a temporary or permanent ban. 3. Temporary Ban Community Impact : A serious violation of community standards, including sustained inappropriate behavior. Consequence : A temporary ban from any sort of interaction or public communication with the community for a specified period of time. No public or private interaction with the people involved, including unsolicited interaction with those enforcing the Code of Conduct, is allowed during this period. Violating these terms may lead to a permanent ban. 4. Permanent Ban Community Impact : Demonstrating a pattern of violation of community standards, including sustained inappropriate behavior, harassment of an individual, or aggression toward or disparagement of classes of individuals. Consequence : A permanent ban from any sort of public interaction within the community.","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"Code of Conduct - Attribution","doc":"This Code of Conduct is adapted from the Contributor Covenant , version 2.1, available at https://www.contributor-covenant.org/version/2/1/code_of_conduct.html . Community Impact Guidelines were inspired by Mozilla's code of conduct enforcement ladder . For answers to common questions about this code of conduct, see the FAQ at https://www.contributor-covenant.org/faq . Translations are available at https://www.contributor-covenant.org/translations .","ref":"code_of_conduct.html#attribution"},{"type":"extras","title":"Contributing","doc":"Please take a moment to review this document in order to make the contribution process easy and effective for everyone involved! Also make sure you read our Code of Conduct that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html"},{"type":"extras","title":"Contributing - Using the issue tracker","doc":"Use the issues tracker for: Bug reports Submitting pull requests We do our best to keep the issue tracker tidy and organized, making it useful for everyone. For example, we classify open issues per perceived difficulty, making it easier for developers to contribute to Uinta .","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Contributing - Bug reports","doc":"A bug is either a demonstrable problem that is caused by the code in the repository, or indicate missing, unclear, or misleading documentation. Good bug reports are extremely helpful - thank you! Guidelines for bug reports: Use the GitHub issue search &amp;mdash; check if the issue has already been reported. Check if the issue has been fixed &amp;mdash; try to reproduce it using the master branch in the repository. Isolate and report the problem &amp;mdash; ideally create a reduced test case. Please try to be as detailed as possible in your report. Include information about your Operating System, as well as your Erlang, Elixir and Uinta versions. Please provide steps to reproduce the issue as well as the outcome you were expecting! All these details will help developers to fix any potential bugs. Example: Short and descriptive example bug report title A summary of the issue and the environment in which it occurs. If suitable, include the steps required to reproduce the bug. This is the first step This is the second step Further steps, etc. &lt;url&gt; - a link to the reduced test case (e.g. a GitHub Gist) Any other information you want to share that is relevant to the issue being reported. This might include the lines of code that you have identified as causing the bug, and potential solutions (and your opinions on their merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing - Contributing Documentation","doc":"Code documentation ( @doc , @moduledoc , @typedoc ) has a special convention: the first paragraph is considered to be a short summary. For functions, macros and callbacks say what it will do. For example write something like: @doc &quot;&quot;&quot; Marks the given value as HTML safe. &quot;&quot;&quot; def safe ( { :safe , value } ) , do : { :safe , value } For modules, protocols and types say what it is. For example write something like: defmodule MyModule do @moduledoc &quot;&quot;&quot; Conveniences for working HTML strings and templates. ... &quot;&quot;&quot; Keep in mind that the first paragraph might show up in a summary somewhere, long texts in the first paragraph create very ugly summaries. As a rule of thumb anything longer than 80 characters is too long. Try to keep unnecessary details out of the first paragraph, it's only there to give a user a quick idea of what the documented &quot;thing&quot; does/is. The rest of the documentation string can contain the details, for example when a value and when nil is returned. If possible include examples, preferably in a form that works with doctests. This makes it easy to test the examples so that they don't go stale and examples are often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation"},{"type":"extras","title":"Contributing - Pull requests","doc":"Good pull requests - patches, improvements, new features - are a fantastic help. They should remain focused in scope and avoid containing unrelated commits. IMPORTANT : By submitting a patch, you agree that your work will be licensed under the license used by the project. If you have any large pull request in mind (e.g. implementing features, refactoring code, etc), please ask first otherwise you risk spending a lot of time working on something that the project's developers might not want to merge into the project. Please adhere to the coding conventions in the project (indentation, accurate comments, etc.) and don't forget to add your own tests and documentation. When working with git, we recommend the following process in order to craft an excellent pull request: Fork the project, clone your fork, and configure the remotes: # Clone your fork of the repo into the current directory git clone https://github.com/&lt;your-username&gt;/uinta # Navigate to the newly cloned directory cd uinta # Assign the original repo to a remote called &quot;upstream&quot; git remote add upstream https://github.com/podium/uinta If you cloned a while ago, get the latest changes from upstream, and update your fork: git checkout master git pull upstream master git push Create a new topic branch (off of master ) to contain your feature, change, or fix. IMPORTANT : Making changes in master is discouraged. You should always keep your local master in sync with upstream master and make your changes in topic branches. git checkout -b &lt;topic-branch-name&gt; Commit your changes in logical chunks. Keep your commit messages organized, with a short description in the first line and more detailed information on the following lines. Feel free to use Git's interactive rebase feature to tidy up your commits before making them public. Make sure all the tests are still passing. mix test Push your topic branch up to your fork: git push origin &lt;topic-branch-name&gt; Open a Pull Request with a clear title and description. If you haven't updated your pull request for a while, you should consider rebasing on master and resolving any conflicts. IMPORTANT : Never ever merge upstream master into your branches. You should always git rebase on master to bring your changes up to date when necessary. git checkout master git pull upstream master git checkout &lt;your-topic-branch&gt; git rebase master Thank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Contributing - Guides","doc":"These Guides aim to be inclusive. We use &quot;we&quot; and &quot;our&quot; instead of &quot;you&quot; and &quot;your&quot; to foster this sense of inclusion. Ideally there is something for everybody in each guide, from beginner to expert. This is hard, maybe impossible. When we need to compromise, we do so on behalf of beginning users because expert users have more tools at their disposal to help themselves. The general pattern we use for presenting information is to first introduce a small, discrete topic, then write a small amount of code to demonstrate the concept, then verify that the code worked. In this way, we build from small, easily digestible concepts into more complex ones. The shorter this cycle is, as long as the information is still clear and complete, the better. For formatting the guides: We use the elixir code fence for all module code. We use the iex for IEx sessions. We use the console code fence for shell commands. We use the html code fence for html templates, even if there is elixir code in the template. We use backticks for filenames and directory paths. We use backticks for module names, function names, and variable names. Documentation line length should hard wrapped at around 100 characters if possible.","ref":"contributing.html#guides"}]